param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$SharePath)
#this programs adds library server(IG) to the given User
$debug1 = '1'
$IGShareAvailable = $false 
#$DelUserName='tejas\administrator'
#$DelPwd='Dell_123$'
#$IGServerFQDN = 'dc.tejas.com'
#$IGUserName = 'tejas\Administrator'
#$IGPassword = 'Dell_123$'
#$VMMServer='scvmm.tejas.com'
$DelegatedAdmin = 'DelegatedAdmin'
$ReadOnlyAdmin = 'ReadOnlyAdmin'
#$SharePath = 'test'
$returnval = @()
<#
$ComputerName="scvmmshibanew.mydomain.com"
$DomainUsername="mydomain\administrator"
$DelPwd= "Dell_123$ "
$tejasFQDN="shiba1138.mydomain.com"
$SharePath="4c4c4544-0053-5810-8044-b5c04f573232"
#>
# Create obj
Function Createcredobj($username, $passwd)
{
    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
    }
    catch
    {
        $mycredsobj = $null
    }
    return $mycredsobj
}

Function CreateVMMObj ($username, $password, $vmmserver)
{
	try
	{
		$Cred = Createcredobj $username $password
		$VMMobj = Get-SCVMMServer -ComputerName $vmmserver -Credential $Cred
#		write-host $VMMobj
	}
	catch
	{
		$returnval = $returnval + "-11"
		$returnval = $returnval + $Error[0].Exception
        if ($debug1 -eq 0)
		{
			#write-host $returnval
		}
		return $returnval
	}
		return $VMMobj
}

Function GetAllUserRoleList($username, $vmmobjadmin)
{
	$UserRoleList = @()
	try
		{	
			$userRoleMembershiplist = Get-SCUserRoleMembership -UserName $username
			foreach($userRoleMembership in $userRoleMembershiplist)
			{
				$UserRole = Get-SCUserRole -Name $userRoleMembership.Name -VMMServer $vmmobjadmin
				$UserRoleList += $UserRole
			}			
		}
		
		catch [exception]
		{
		$returnval = $returnval + "FAIL"
        $returnval = $returnval + "Status:Could not Get UserRole for the given user"
		}
		return $UserRoleList

}

Function GetUserRolesToBeScoped ($userrolelist, $igserverfqdn)
{
# Send true only if all the UserRoles in the List have Library Server Added.
$UserRolesToBeScoped = @()
$add = $false

 foreach ($UserRole in $userrolelist )
	{	$add = $true
		foreach($LibServer in $UserRole.LibraryServer)
		{
			if( $LibServer.Name.ToString() -eq $igserverfqdn)
			{
				$add = $false
			}	
		}
		if($add)
		{
			$UserRolesToBeScoped += $UserRole
		}
	}
return $UserRolesToBeScoped
	
}


Function FindIGInVMMServer($vmmobj,$igserver)
{
	$AllLibraryServers = Get-SCLibraryServer -VMMServer $vmmobj
	if ($AllLibraryServers -eq $null)
	{
		return $false
	}
	else
	{	foreach ($LibraryServer in $AllLibraryServers )
		{
			if ($LibraryServer.FQDN -eq $igserver)
			{
				#write-host "Admin: IG Server is one of the Library Server, Just need to add it to the user"
				return $true
			}
		}
	}
	return $false
		
}

Function AddServerToUserRoles ($userroles, $vmmobj, $igfqdn)
{
	#write-host "Adding Scope to user roles: " $userroles "for IG :" $igfqdn
	foreach ($UsrRole in $userroles )
	{
		# Library Server Scope addition:
		
		# Administrator - cant add any scope
		# Tenant - cant add library server
		# ReadOnly - can add Library Server
		# Delegated - can add Library Server
		# In our case its only Delegated admin who needs to get scope
		
		if (($UsrRole.Profile.ToString() -eq $DelegatedAdmin) -or ($UsrRole.Profile.ToString() -eq $ReadOnlyAdmin))
		{
		$scopeToAdd = @()
		$scopeToAdd += Get-SCLibraryServer -VMMServer $vmmobj | where { $_.Name -match $igfqdn }
		Set-SCUserRole -UserRole $UsrRole -AddScope $scopeToAdd  | out-null
		}
	}
	
}


############################# Logic Starts here ############################
#$ComputerName,$DelUserName,$DomainUsername,$DelPwd,$tejasFQDN,$SharePath

$SharePath = $SharePath -replace "\\n\\r", " "

#import SCVMM related cmdlets
import-module virtualmachinemanager

#Create VMM Object for User and Admin
$CredAdmin = Createcredobj $DomainUsername $DelPwd

$VMMObjUser = CreateVMMObj $DomainUsername $DelPwd $ComputerName
$VMMObjAdmin = CreateVMMObj $DomainUsername $DelPwd $ComputerName

#Get User Roles for the User
$AllUserRoleList = GetAllUserRoleList $DomainUsername $VMMObjAdmin

#Get the User Roles that needs addition of Library Server
$UserRolesToScope = GetUserRolesToBeScoped $AllUserRoleList $ComputerName

$IGServerFQDN=$ComputerName

if( $UserRolesToScope -eq $null)
{	#Add Library Share 
	try
	{
		$LibShare = Get-SCLibraryShare -VMMServer $VMMObjUser | where { $_.LibraryServer.Name -eq $IGServerFQDN -and $_.Name -eq $SharePath}
		#write-host $LibShare
		$FullSharePath = '\\' + $IGServerFQDN + '\' +$SharePath
	
		if($LibShare -eq $null)
		{
			Add-SCLibraryShare -SharePath $FullSharePath | out-null
		}
		else
		{
			
		$returnval = $returnval + "SUCCESS"
		$returnval = $returnval + "Status:Library Share is already added to the user"
		
		return $returnval
		}
	}
	catch
	{
		$returnval = $returnval + "FAIL"
		$returnval = $returnval + "Status:Exception occurred while adding the Library Share"
		
		return $returnval
	}
	#write-host "All User Roles of user: " $DelUserName " have access to IG Library server: " $IGServerFQDN
		$returnval = $returnval + "SUCCESS"
		$returnval = $returnval + "Status:User has access to IG Library Server"
		
	return $returnval
}
else 
{
	#Write-host "Adding Scope to following user roles: 	"
	#write-host $UserRolesToScope
	
	#Add IG Server as Library Server if it was never added
	$IsIGAddedinVMM = FindIGInVMMServer $VMMObjAdmin $IGServerFQDN
	
	if( $IsIGAddedinVMM -eq $false)
	{
	#	write-host "Adding IG Server: " $IGServerFQDN "to VMM Server ..."
		try
			{
				$t = Add-SCLibraryServer -ComputerName $IGServerFQDN -Credential $DelPwd

			}
		catch 
			{
				$returnjson="Status:Exception occurred while adding Computer: "+$IGServerFQDN+" as Library Server to VMM "+$_.Exception.Message
				$returnval = $returnval + "FAIL"
				$returnval = $returnval + $returnjson
				
				return $returnval
			} 	
			if($t -eq $null)
			{
				$returnjson="Status:Exception occurred while adding Computer: "+$IGServerFQDN+" as Library Server to VMM "+$_.Exception.Message
				$returnval = $returnval + "FAIL"
				$returnval = $returnval + $returnjson
				return $returnval
			}
	}
	
	#Add Library Share 
	try
	{
		$LibShare = Get-SCLibraryShare -VMMServer $VMMObjAdmin | where { $_.LibraryServer.Name -eq $IGServerFQDN -and $_.Name -eq $SharePath}
		#write-host $LibShare
		$FullSharePath = '\\' + $IGServerFQDN + '\' +$SharePath
	
		if($LibShare -eq $null)
		{
			Add-SCLibraryShare -SharePath $FullSharePath | out-null
		}
		else
		{
			
		$returnval = $returnval + "SUCCESS"
		$returnval = $returnval + "STATUS:Library Share is already added to the user"
				
		return $returnval
		}
	}
	catch
	{
		$returnjson="Share:Exception occurred while adding the Library Share "+$_.Exception.Message
		$returnval = $returnval + "FAIL"
		$returnval = $returnval + $returnjson
		
		return $returnval
	}
	
	#Adding IG Server to User Roles
	try
	{
		AddServerToUserRoles $UserRolesToScope $VMMObjAdmin $IGServerFQDN
	}
	catch
	{
		$returnjson="Status: Exception occurred while scoping Library Server to User Roles "+$_.Exception.Message
		$returnval = $returnval + "FAIL"
		$returnval = $returnval + $returnjson
		return $returnval
	}
		$returnval = $returnval + "SUCCESS"
		$returnval = $returnval + "Status:User has access to IG Library Server"
		
	return $returnval
	
}