param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$versionInfo)

#$VMMServer = "SCVMM.tejas.com"
#$DelUserName = "delldemo\administrator"
#$DelPwd = Get-Credential -Credential $SCVMMAdminUser
#$TejasFQDN = "tejas.com"

$versionInfo = $versionInfo -replace "\\n\\r", " "
# Create obj
Function Createcredobj($username, $passwd)
{

    try{
        $secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        # handling of exception and returning back is having some issues 
        #$errorMessage = $Error[0].exception
        if ($debug1 -eq 0)
        {
            write-host "inside catch"
        }
    }

    return $mycredsobj

}

$returnValue = @()
$returnValueSCVVM = @()
$returnValueSCCM = @()

$IsSCVMM=0;
$IsSCCM=0;
$version="Tejas"
if($versionInfo -eq $version)
{
	try 
	{
		#$SCVMMUserName=$DelUserName.split('\')[1]
		import-module virtualmachinemanager
		$Credential = Createcredobj $DomainUsername $DelPwd
		$VMMobj = Get-SCVMMServer $ComputerName -Credential $Credential

		if ( $VMMobj -ne $null)
		{
			#Server is SCVMM, returning the SCVMM Product version
			write-host "Server is SCVMM, returning the SCVMM Product version : " +$VMMobj.ProductVersion
			$resultjson= "ConsoleType:SCVMM,VERSION:"+ $VMMobj.ProductVersion
			$returnValue = $returnValue + "SUCCESS" + $resultjson
			$IsSCVMM=1;
		}
		else
		{
			$IsSCVMM=0;
		}
	}
	catch [system.exception]
	{
		   $IsSCVMM=0;
		   $returnValueSCVVM = $returnValueSCVVM + "FAIL"
		   $returnValueSCVVM = $returnValueSCVVM + $_.Exception.Message

	}

	if($IsSCVMM -eq 0)
	{
		#checking for SCCM version details, sccm 2012 is not supporting powershell module below
		try
		{
			
			$sccmCred = Createcredobj $DomainUsername $DelPwd
			$Server = $ComputerName.Split('.')[0]
				$version= Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
				Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
				$PSD = Get-PSDrive -PSProvider CMSite
				if($PSD -eq $null){
					New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[1]
					$PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
					$SiteCode= CD "$($PSDN):"
				}else{
					$SiteCode= CD "$($PSD):"	
					}
					$VMMobj= Get-CMSite
					
					#Add the User Role
					#New-CMAdministrativeUser -Name $args[0] -RoleName "Full Administrator"
					#Add-CMSecurityRoleToAdministrativeUser -AdministrativeUserName $args[0] -RoleName "Full Administrator"
				   
					if ( $VMMobj -ne $null )
					 {
							#Server is SCCM, returning the SCCM Product version
							write-host "Server is SCCM, returning the SCCM Product version : " +$VMMobj.Version
							return  $VMMobj.Version
					
					 }

			}-Args $DomainUsername,$ComputerName -ErrorVariable errmsg  2>$null

	   
				If (![string]::IsNullOrWhiteSpace($errmsg)){
					$IsSCCM=0;
					$returnValueSCCM = $returnValueSCCM + "FAIL"
					$returnValueSCCM = $returnValueSCCM + $errmsg
					$returnValue = $returnValueSCCM

					#"unable to connect to the SCCM management server, Could be because of not able to get local host FQDN or Integration Gateway failure"
				}
				 else {
					$resultjson= "ConsoleType:SCCM,VERSION:"+ $version
					$returnValue = $returnValue + "SUCCESS"+ $resultjson
					$IsSCCM=1;
					write-host "SCVMM Console Enrolment is successful"
				}
				
		}
		catch [system.exception]
		{
			   $IsSCCM=0;
			   $returnValueSCCM = $returnValueSCCM +"FAIL"+ $_.Exception.Message
			   $returnValue = $returnValueSCCM
			   write-host "SCVMM Console Enrolment is failed"
		}		
	}

}
else{
	#checking for scom ms and details
	#if(($IsSCCM -eq 0)-AND($IsSCVMM -eq 0))
	#{
		try
		{
			$Credential = Createcredobj $DomainUsername $DelPwd
			$Server = $ComputerName.Split('.')[0]
			Import-Module -Name OperationsManager
			$name = Get-SCOMManagementServer
			if($name -ne $null)
			{    
				$mg = '{"consoleType":"SCOM","scomManagementGroup": "'+$name[0].ManagementGroup.name+'","server":['
				For ($i=0;$i -lt $name.length;$i++)
				{
				if($i -gt 0)
				{
					$ms = $ms + ","
				}
				$ms = $ms + '{ "managementServer":"'+$name[$i].DisplayName+'","version":"'+$name[$i].Version+'"}'
				}
				$ms = $ms + "]}"
				$returnValue = "SUCCESS"+ "`n"+$mg + $ms
			 }
		}
		catch [system.exception]
		{
			   $IsSCOM=0;
			   $returnValueSCOM = "FAIL"+"`n"+ $_.Exception.Message
			   $returnValue = $returnValueSCOM
		}
	#}
}
return $returnValue
