param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)

#$VMMServer = "SCVMM.tejas.com"
#$DelUserName = "delldemo\administrator"
#$DelPwd = Get-Credential -Credential $SCVMMAdminUser
#$TejasFQDN = "tejas.com"


# Create obj
Function Createcredobj($username, $passwd)
{

    try{
        $secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        # handling of exception and returning back is having some issues 
        #$errorMessage = $Error[0].exception
        if ($debug1 -eq 0)
        {
            write-host "inside catch"
        }
    }

    return $mycredsobj

}

$returnValue = @()

try 
{
#import SCVMM related cmdlets
import-module virtualmachinemanager

	$Credential = Createcredobj $DomainUsername $DelPwd
	$VMMobj = Get-SCVMMServer -ComputerName $ComputerName -Credential $Credential

	if ( $VMMobj -eq $null)
	{
		$reurnjson="Status:Could be because of not able to get local host FQDN or Integration Gateway failure"		
		$returnValue = $returnValue + "FAIL"
		$returnValue = $returnValue+ $returnjson
	}
	else
	{
		#Application profile name and Description
		$appProfileName = "OMIMSSC SCVMM Console Extension Registration Profile"
		$appProfileDescription = "*DO NOT DELETE* This is auto generated and used by OpenManage Integrations for Microsoft System Center. OMIMSSC SCVMM Console Extension will not work if you delete this profile."

		#Retrive Application profile and check if Application profile exist 
		$AppProfile = Get-SCApplicationProfile -Name  $appProfileName -VMMServer $VMMobj 
				
		if($AppProfile -eq $null)
		{
			$reurnjson="Status:DLCI Application Profile is not registered in given SCVMM server"
			$returnValue = $returnValue + "FAIL" 
			$returnValue = $returnValue + $returnjson
			 
			
		}
		else
		{
			#Removing Application profile from SCVMM
			
			$RemoveAppProfile = Remove-SCApplicationProfile -ApplicationProfile $AppProfile
						
			if($RemoveAppProfile -eq $null)
			{
				$reurnjson="Status:Unable to Delete the DLCI Application Profile from Library of SCVMM server and try again"
				$returnValue = $returnValue + "FAIL" 
				$returnValue = $returnValue + $returnjson
				 
			} 
			else
			{
			   $reurnjson="Status:Successfully un-register with VMM server"	
			   write-host "Successfully de enrol with VMM server"
			   $returnValue = $returnValue + "SUCCESS" 
			   $returnValue = $returnValue + $returnjson
			   
			}
		}
	}
}
catch [system.exception]
            {
            	$reurnjson="Status:"+$_.Exception.Message	
                $returnValue = $returnValue + "FAIL"
                $returnValue = $returnValue + $reurnjson
                write-host "De enrol with VMM server failed"
            }
write-host "Returning from DeEnrolSCVMM : " +$returnValue
return $returnValue
