param($VMMServer,$DomainUsername,$DelPwd,$tejasFQDN,$otherInfo)
## This script gets the logical network details from scvmm
$debug1 = 1

# Return Value
$returnval = @()
$temp = @("null") 
  
#$DelUserName='tejas\administrator'
#$DelPwd='Dell_123$'
#$VMMServer='scvmm.tejas.com'
#$libShare = '\\orchestrator.tejas.com\SCVMMLib'
#$uuid = '4c4c4544-0039-4810-8051-b2c04f383253'
$stdFolder = '\Dell\Drivers\'

# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

# Create SCVMM Cred obj    
    $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Status:Could not create credentail object for the given SCVMM user"
        return $returnval
    }

# A user can have mutiple role, in Tejasconext we are connecting always as DelegatedAdmin Role.

    try 
    {    
    	$otherInfo = $otherInfo -replace "\\n\\r", " "	
    	$libShare=$otherInfo.split(',')[0]
    	$uuid=$otherInfo.split(',')[1]
    	
    	#import SCVMM related cmdlets
		import-module virtualmachinemanager
        $VMMobj = Get-SCVMMServer -ComputerName $VMMServer -Credential $scvmmcreds 
    }
    catch [exception]
    {
    	$returnjson="Status:"+$Error[0].Exception
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + $returnjson
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
    }

    if ( $VMMobj -eq $null)
    {
    	$returnjson="Status:SCVMM host not reachable"
        $returnval = $returnval + "FAIL"
        $returnval = $returnval + $returnjson
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
       
    }
	else
    {
		
		try
		{
			# get library server
            $ErrorActionPreference = "Stop";
            $libServer = Get-SCLibraryShare -VMMServer $VMMobj | where { $_.Path -eq $libShare } 		


		    # No lib server shrare found
			if ($libServer -eq $null )
			{
				if ($debug1 -eq 0)
				{
					write-host "No library share found for the given path in SCVMM"
				}
				$returnjson="Status:No library share found for in SCVMM for path "+$libShare
				$returnval = $returnval + "FAIL"
				$returnval = $returnval + $returnjson
				return $returnval
				
			}
			else # Found some Lib server
			{
				if ($debug1 -eq 0)
				{
					write-host "library share found for the given path in SCVMM"
				}
                # Check if the folder structure exists else create
                $driverPath = $libShare + $stdFolder + $uuid
                try
                {
                     if((Test-Path -Path $driverPath))
                      {
						remove-item -Path $driverPath -Force -Recurse| Out-Null
                        		
                      }
                }
                catch [exception]
		        {
		        	$returnjson="Status:Exception while deleting drivers from library share "+$driverPath+" "+$_.Exception.Message
					$returnval = $returnval + "FAIL"
				    $returnval = $returnval + $returnjson
				

				    if ($debug1 -eq 0)
				    {
					    write-host $returnval
				    }
				    return $returnval
		        }
                
                # Refresh lib server (not reqd here)
                Read-SCLibraryShare -LibraryShare $libServer | Out-Null
				
				$returnjson="Status:Deleted LC drivers from Library Server successfully"
				$returnval = $returnval + "SUCCESS"
				$returnval = $returnval + $returnjson

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
			}

		}
		catch [exception]
		{
				$returnjson="Status:Exception occured while getting library share info for "+$libShare+$_.Exception.Message
				$returnval = $returnval + "FAIL"
			    $returnval = $returnval + $returnjson
				

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
		}

}