param($VMMServer,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)
## This script gets all the Hosts present in SCVMM 


$debug1 = 1

# Return Value
$returnval = @()

  
#$DelUserName='tejas\administrator'
#$DelPwd='Dell_123$'
#$VMMServer='scvmm'



# Create Credential obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

#import SCVMM related cmdlets
import-module virtualmachinemanager

# Create SCVMM Cred obj    
    $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Status:Could not create credentail object for the given SCVMM user"
        return $returnval
    }


# A user can have mutiple role, in Tejasconext we are connecting always as DelegatedAdmin Role.

    try 
    {
        $VMMobj = Get-SCVMMServer -ComputerName $VMMServer -Credential $scvmmcreds 
    }
    catch [exception]
    {
        $returnval = $returnval + "-3"
		$returnval = $returnval + $Error[0].Exception
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
    }

    if ( $VMMobj -eq $null)
    {
        $returnval = $returnval + "-7"
        $returnval = $returnval + "SCVMM host not reachable"
       
    }

else
    {

		#SCVMMHost reachable

		try
		{
			# Get all Hosts in SCVMM
			$AllHosts = (Get-SCVMhost -VMMServer $VMMobj )

			
			if ($AllHosts -eq $null)
			{
				$returnval = $returnval + "SUCCESS"
				$returnval = $returnval + "SCVMM Operation Completed Unsuccessfully"
				

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval

			}
			else{
			if ($AllHosts.Count -gt 0)
        		{
        			# Found Hosts
        			
        		foreach ($h in $AllHosts)
					{
						$details=$details+$h.PhysicalMachine.BMCAddress+"_"+$h.ComputerName+"_"+$h.HostCluster+"_"+$h.VMHostGroup+";"
					}
				$returnjson="Count:"+$AllHosts.Count+",Details:"+$details
				$returnval = $returnval + "SUCCESS"
				$returnval = $returnval + $returnjson 
					
				
			}
			else
       			{
				#If hosts does not exist
            			$returnval = $returnval + "SUCCESS"
            			$returnval = $returnval + "SCVMM Operation Completed Successfully"
            			            
				#end of else 
        		}
				}
		}
		catch [exception]
		{
				$returnval = $returnval + "FAIL"
				$returnval = $returnval + $Error[0].Exception
				
		}

}


if ($debug1 -eq 0)
{
    write-host $returnval
}


return $returnval
