param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)

<#
$ComputerName = "sksccm.mydomain.com"
$DomainUsername = "mydomain\administrator"
$DelPwd = "Dell_123$"
$tejasFQDN = "tejas1137.mydomain.com"
$tejasIP="100.96.20.207"
#>

Function Createcredobj($username, $passwd){
    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}



$tejasIP = $tejasIP -replace "\\n\\r", " "


$returnval = @()


$sccmCred= Createcredobj $DomainUsername $DelPwd

try{
	#step 0. Create connection with SCCM machine and get the site code
    $siteCode=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
            Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	    $PSD = Get-PSDrive -PSProvider CMSite
	        if($PSD -eq $null){
			    New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[0]
			    $PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			    $SiteCode= CD "$($PSDN):"
		    }else{
	            $SiteCode= CD "$($PSD):"	
		    }
	        $VMMobj= Get-CMSite
            if ( $VMMobj -ne $null ){
			
			    return $VMMobj.SiteCode
	        }else{
			    return "Site Code of the SC was not identified"
		    }
    }-Args $ComputerName -ErrorVariable errmsg  2>$null
	#step 1. Create connection with SCCM machine and get the site code
	$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
		
		############### CONSTANTS ###########################
		
		set-variable -name Response_Success -value "SUCCESS" -option constant
		set-variable -name Response_FAIL -value "FAIL" -option constant
		set-variable -name Exception_Code -value 101 -option constant
		set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
		set-variable -name collectionNameAllSystems -value "All Systems" -option constant
		set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
		set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
		set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
		set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
		set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
		set-variable -name osRhel -value "rhel" -option constant
		set-variable -name osEsxi -value "esxi" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		set-variable -name collectionNameOSDeployed -value "Managed Dell Lifecycle Controller(OS Deployed)" -option constant
		set-variable -name collectionNameOSUnknown -value  "Managed Dell Lifecycle Controller(OS Unknown)" -option constant
		set-variable -name collectionCommentOSDeployed -value "All Dell PowerEdge 11G (and above) servers with ConfigurationManager Client" -option constant
		set-variable -name collectionCommentOSUnknown -value "All Dell PowerEdge 11G (and above) servers without ConfigurationManager Client"-option constant
		
		############### CONSTANTS ###########################
		
		############################## FUNCTIONS START ##################################

        function Write-Log
        {
            param (
                [Parameter(Mandatory)]
                [string]$Message,
        
                [Parameter()]
                [ValidateSet('1','2','3')]
                [int]$Severity = 1 ## Default to a low severity. Otherwise, override
            )
    
            $line = [pscustomobject]@{
                'DateTime' = (Get-Date -Format "yyyy-MM-dd HH:mm:ss:ffff")
                'Message' = $Message
            }
    
            ## Ensure that $LogFilePath is set to a global variable at the top of script
            $line | Export-Csv -Path $LogFilePath -Append -NoTypeInformation
        }

        

		Function getAllCollection ($hostnameparam,$nsparam){

		$collList=@()
		$collectionList=""
		$queryColl="select SC.Name from SMS_Collection SC join SMS_FullCollectionMembership SFCM on SC.CollectionID = SFCM.CollectionID Where SFCM.Name = '$hostnameparam'"
		$resultColl=Get-WMIObject -Query $queryColl -Namespace $nsparam
	
		foreach($coll in $resultColl){
			$collList=$collList+$coll.Name
		}
         Write-Log -Message "All Collection: $collList"
       
		foreach($col in $collList){
			if($col -eq $collectionNameImportDellServers){
				$isImpoterdDellColExist=$true
			}
		
			if($col -eq $collectionNameAllDellLCControllers){
				$isAllDellColExist=$true
			}
			if($col -eq "All Desktop and Server Clients" -or $col -eq "All Systems")
			{
				#Write-Log -Message "System is present in : All Desktop and Server Clients OR All Systems"
			}
		    else{
			$collectionList=$collectionList+$col+"&"
            }
		}
	
		if(!$isImpoterdDellColExist){
			$collectionList=$collectionList+$collectionNameImportDellServers+"&"
		}
		if(!$isAllDellColExist){
			$collectionList=$collectionList+$collectionNameAllDellLCControllers+"&"
		}
	
		$list=$collectionList.SubString(0,$collectionList.Length-1)
	    Write-Log -Message  "List: $list"
		return $list
	}
    ############################## FUNCTIONS END ##################################
        $logBasePath="$(split-path $Env:SMS_ADMIN_UI_PATH)";
        $logFilePath="OMIMSSC_Discovery.log"

        $global:LogFilePath = Join-Path $logBasePath $logFilePath

       try{

        if (!(Test-Path $LogFilePath)) {
            
            $NewLogFile = New-Item $LogFilePath -Force -ItemType File
          }

        else {
            # Nothing to see here yet.
            }
         }catch{
            $tempPath =[System.IO.Path]::GetTempPath()
            $basePath = [io.path]::combine($tempPath + "Log")
            $logFile=  Join-Path $basePath  $logFilePath 
            [system.io.directory]::CreateDirectory($logFile)
            $LogFilePath=$logFile
         }
	    Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		Write-Log -Message " Find all host in SCCM Started"
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		$site=$args[2]
		$ns="root\sms\site_$site"
		
		#Step 2. Check if the Collection "all Systems" exists or not
		$query="Select * from sms_collection where Name='$collectionNameAllSystems'"
		$response=get-wmiobject -query $query -namespace $ns
		
		$collectionID=""

		if($response -ne $null){
			foreach($row in $response){
				#Step 3. get the collection Id
				$collectionId=$row.CollectionId
			}
		}else{
			#the Collection does not exist
            Write-Log -Message "Message:The Collection $collectionNameAllSystems does not exist"
			return "Status:$response_FAIL,Message:The Collection $collectionNameAllSystems does not exist"
		}
		
		#step 4. Get the Host Names in the collection
        Write-Log -Message "Message:Get the Host Names in the collection"
		$hostNameArr=""
		if(![string]::IsNullorEmpty($collectionID)){
			$query="Select * from sms_fullCollectionMembership where CollectionId='$collectionID'"
			$response=get-wmiobject -query $query -namespace $ns
			
		
			if($response -ne $null){
				foreach($row in $response){
                    Write-Log -Message $row.Name
					$hostNameArr=$hostNameArr+$row.Name+","

				}
			}else{
                   Write-Log -Message "Message:No host found in SMS_FullCollectionMembership"
				
			}			
		}
		$hostNameArr=$hostNameArr.SubString(0,$hostNameArr.Length-1)
		#step 5. If the Hostlist is empty send a blank host detail list
		$hostDetailList=@()
        $hostArr=""
        $hostNameList=$hostNameArr.Split(",")
		if($hostNameList -eq $null){
			#return a blank host detail list 
            Write-Log -Message "Message:Host detail list is Empty"
			$hostDetailList=@()
		}else{
			#Step 6. Fetch the Host Details from sms_r_idrac
            Write-Log -Message "Message:Host detail list is not Empty"
            Write-Log -Message "Message:Fetch the Host Details from sms_r_idrac"
            Write-Log -Message "hostNameList: $hostNameList"
			foreach($catt in $hostNameList){
                Write-Log -Message "Host Name:$catt"
				$query="Select * from SMS_R_IDRAC where Netbiosname='$catt'"
				$response=get-wmiobject -query $query -namespace $ns
				
				if($response -ne $null){
					
					$ipaddress=""
					$name=""
					$hostname=""
					$groupname=""
					
					foreach($row in $response){
						$ipaddress=$row.IPAddresses
						 Write-Log -Message "IPAddress: $ipaddress"
						if(![string]::isNullorEmpty($ipaddress)){
							$clusterFDQN=""
							$hostname=$catt
							#Step 7. Get the collection names associated with the host
							$groupname=(getAllCollection $hostname $ns)
							$detail="$hostname*$ipaddress*$clusterFDQN*$groupname;"
                            Write-Log -Message "Details: $detail"
							#$hostDetailList=$hostDetailList+@($hostname,$ipaddress,$clusterFDQN,$groupname)
							Write-Log -Message "Current Host: $hostname*$ipaddress"
							$isPresent=$false
							$str="$hostname*$ipaddress"
							foreach ($element in $hostDetailList) 
                            {   Write-Log -Message "element: $element"
								if($element.Contains($str))
								{
								   $isPresent=$true
                                  Write-Log -Message "Matched: $hostname*$ipaddress"
								}
                          
							}
							if(!$isPresent){
								$hostDetailList=$hostDetailList + $detail
                                Write-Log -Message "Current List: $hostDetailList"
							}
						}
					}
                     
					
				}
				
			}
            foreach ($element in $hostDetailList) {
	            $hostArr=$hostArr+$element
            }
            
		}
		
		#Step 8. Prepare the respone 
		if($hostDetailList -eq $null -or $hostDetailList.Count -eq 0){
            Write-Log -Message "Message:No Matching Host Found"
            Write-Log -Message "--------------------------------------------------------------------------------------"
            Write-Log -Message "--------------------------------------------------------------------------------------"
		    Write-Log -Message "Find all host in SCCM Finished"
            Write-Log -Message "--------------------------------------------------------------------------------------"
            Write-Log -Message "--------------------------------------------------------------------------------------"
			return "Status:$response_FAIl,Message:No Matching Host Found"
		}else{
			$hostCount=$hostDetailList.Count
			$returnJson="HostCount:$hostCount,HostList:$hostArr"
			$returnJson=$returnJson.subString(0,$returnJson.Length-1)
            Write-Log -Message $returnJson
            Write-Log -Message "--------------------------------------------------------------------------------------"
            Write-Log -Message "--------------------------------------------------------------------------------------"
		    Write-Log -Message "Find all host in SCCM Finished"
            Write-Log -Message "--------------------------------------------------------------------------------------"
            Write-Log -Message "--------------------------------------------------------------------------------------"
			return $returnJson
		}
			
	}-Args $DomainUsername,$ComputerName,$siteCode -ErrorVariable errmsg  2>$null
	

	if($emsg -match "FAIL"){
		$returnval=$returnval+"FAIL"
		$returnval=$returnval+$emsg
		return $returnval
	}else{
		$returnval=$returnval+"SUCCESS"
		$returnval=$returnval+$emsg
		return $returnval
	}
}catch{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+$_.Exception.Message
	return $returnval
}