param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)


Function Createcredobj($username, $passwd){
    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}

$info = $info -replace "\\n\\r", " "

$returnval = @()

$sccmCred= Createcredobj $DomainUsername $DelPwd

$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
	
	#Step 1. create objects from smbios guid
       		
	$nodeId=$args[2].split(",")[0]
	$serviceTag=$args[2].split(",")[1]
	$hostname=$args[2].split(",")[2]
	$model=$args[2].split(",")[3]
	$guid=$args[2].split(",")[4]
	$platformGuid=$args[2].split(",")[5]
	$macAddress=$args[2].split(",")[6].split("?")
	$ipsubnet=$args[2].split(",")[7]
	$osnames=$args[2].split(",")[8].split(":")
	$driverpackversion=$args[2].split(",")[9]
	$ipaddresses=$args[2].split(",")[10]

        
      
	#Step 2. Get the Site Code
       Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	  	$PSD = Get-PSDrive -PSProvider CMSite
	   if($PSD -eq $null){
		New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[1]
		$PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
		$SiteCode= CD "$($PSDN):"
	}else{
	       $SiteCode= CD "$($PSD):"	
	}
	   $VMMobj= Get-CMSite
       if ( $VMMobj -ne $null ){
		
		$site=$VMMobj.SiteCode
	   }else{
		return "Site Code of the SC was not identified"
	}
	
	if($ipaddresses.Count -eq 0){
		return "Status:$Response_FAIL,Message:IP Address param is null / empty"
	}
	
	#Create new hosts for Import Dell Servers
	if($macAddress -ne $null -and $macAddress.Count -gt 0){
	
		Set-Location $site":"
		$WMIConnection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Site")
		
		$NewEntry = $WMIConnection.psbase.GetMethodParameters("ImportMachineEntry")
		
		$NewEntry.NetbiosName=$hostName
		$NewEntry.SMBIOSGUID=$guid
		$NewEntry.MACAddress =$macAddress[0]
		$NewEntry.OverwriteExistingRecord=$true
		
		$ImportMachineEntryResponse = $WMIConnection.psbase.InvokeMethod("ImportMachineEntry",$NewEntry,$null)
	
		return $ImportMachineEntryResponse.ReturnValue
	}
}-Args $DomainUsername,$ComputerName,$info -ErrorVariable errmsg  2>$null

if($emsg -eq 0){
	$returnval=$returnval+"SUCCESS"
	$returnval=$returnval+$emsg
}else{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+"ImportMachineEntry failed"
}
return $returnval