<#
$idracIPAddress = "192.168.10.33"
#$scvmmInputFileName = "C:\SCVMM_BareMetalDeployment_Inputs.xml" ;

#Start of SCVMM hyperv deployment
#Create-Log "Start of SCVMM hyperv deployment" "INFO"
[xml]$hyperVDepInputs = new-object System.Xml.XmlDocument
$file = resolve-path($scvmmInputFileName)
$hyperVDepInputs.load($file)

$BMCRAA = Get-DELLSCRunAsAccount -Name $hyperVDepInputs.VMMBMetalDeploymentInputs.ee
if($BMCRAA -eq $Null)
{
                $securePassword = ConvertTo-SecureString �$password� -AsPlainText -Force
                $credentials = New-Object System.management.automation.PSCredential $username,$securePassword
                $BMCRAA = New-DELLSCRunAsAccount -Name $hyperVDepInputs.VMMBMetalDeploymentInputs.BMCRunAsAccount -Credential $credentials
}
#Create-Log $hyperVDepInputs.VMMBMetalDeploymentInputs.BMCProtocol "INFO"
$NewPhysicalComputer1 = Find-SCComputer -BMCAddress $idracIPAddress -BMCRunAsAccount $BMCRAA -BMCProtocol $hyperVDepInputs.VMMBMetalDeploymentInputs.BMCProtocol
$HostGroup = Get-DELLSCVMHostGroup | where { $_.Path -eq $hyperVDepInputs.VMMBMetalDeploymentInputs.HostGroup}
$HostProfile = Get-DELLSCVMHostProfile -Name $hyperVDepInputs.VMMBMetalDeploymentInputs.HostProfile
# $SMBIOSID = Get-SMBIOSID $username $password $idracIPAddress
$SMBIOSID = "4c4c4544-0032-4d10-8033-b9c04f363253"

#$FirstNic = Get-MACOfFirstNic $username $password $idracIPAddress
$FirstNic = "a4:ba:db:34:cb:02"

#$StaticIPOfMN = $hyperVDepInputs.VMMBMetalDeploymentInputs.staticIPAddress
#$SubnetOfMN = $hyperVDepInputs.VMMBMetalDeploymentInputs.Subnet
$SubnetOfMN = "255.255.255.0"
$logString = "SMBIOSID : $SMBIOSID , `nFirstNic : $FirstNic`nBMCAddress : " + $NewPhysicalComputer1.BMCAddress
#Create-Log $logString "INFO"
#New-DELLSCVMHost -VMHostGroup $HostGroup -VMHostProfile $HostProfile -BMCAddress $NewPhysicalComputer1.BMCAddress -BMCRunAsAccount $BMCRAA -BMCProtocol $hyperVDepInputs.VMMBMetalDeploymentInputs.BMCProtocol -SMBIOSGUID $SMBIOSID -BypassADMachineAccountCheck -ComputerName $hyperVDepInputs.VMMBMetalDeploymentInputs.ComputerName -ManagementAdapterMACAddress $FirstNic -Subnet $SubnetOfMN -IPAddress $StaticIPOfMN
New-DELLSCVMHost -VMHostGroup $HostGroup -VMHostProfile $HostProfile -BMCAddress $NewPhysicalComputer1.BMCAddress -BMCRunAsAccount $BMCRAA -BMCProtocol $hyperVDepInputs.VMMBMetalDeploymentInputs.BMCProtocol -SMBIOSGUID $SMBIOSID -BypassADMachineAccountCheck -ComputerName $hyperVDepInputs.VMMBMetalDeploymentInputs.ComputerName -ManagementAdapterMACAddress $FirstNic
#Create-Log "End of SCVMM hyperv deployment`n`n" "INFO"

#>


# Please don't use the same paramaters name in the script, as these paramaters will be replaced by the actual values  by C# program
    #$DelUserName 
    #$DelPwd
    #$VMMServer
	$idracIPAddress

# Please don't use the same paramaters name in the script, as these paramaters will be replaced by the actual values  by C# program

#######  TEST from powershell prompt ###################
## For Debugging directly in the power shell IDE ...uncomment below lines 
#test
$debug1 = 1
Function test()
{
   # $DelUserName='Tejas\administrator'
   # $DelPwd='Dell_123$'
   # $VMMServer='scvmm'

    
   # import-module "C:\\Program Files\\Microsoft System Center 2012\\Virtual Machine Manager\\bin\\psModules\\virtualmachinemanager"
  
}

## For Debugging directly in the power shell IDE ...uncomment below lines 

# Create obj
Function Createcredobj($username, $passwd)
{

    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
		# handling of exception and returning back is having some issues 
        #$errorMessage = $Error[0].exception
        if ($debug1 -eq 0)
        {
            write-host "inside catch"
        }
    }

    return $mycredsobj

}



# Return Value
# 
 $returnval = @()
 

if ($debug1 -eq 0)
{
    write-host $VMMServer $RunAsUserName $RunAsPwd $DelUserName $DelPwd $RunAsDesc
}
 
# Create Runas account cred object 
    $mycreds = Createcredobj $RunAsUserName $RunAsPwd
   
# Create SCVMM Cred obj    
    $scvmmcreds = Createcredobj $DelUserName $DelPwd
   
    # A user can have mutiple role, in Tejasconext we are connecting always as DelegatedAdmin Role.
    $VMMobj = Get-SCVMMServer -ComputerName $($args[0]) -Credential $scvmmcreds 
    if ( $VMMobj -eq $null)
    {
        $returnval = $returnval + "-7"
        $returnval = $returnval + "SCVMM host not reachable"
        $returnval = $returnval + "-7"
        $returnval = $returnval + "SCVMM host not reachable"
    }
	else
    {
	    # do valid stuff
		$BMCRAA = Get-SCRunAsAccount -Name $($args[3])
		if($BMCRAA -eq $Null)
		{
			#Exception out / Messaging that RunAsAccount is not present, Need to recreate.
		}
		else
		{
			$BMCProtocol = "SMASH"
						
		}

	}
#write-host "Params passed - "
#write-host "1" + $cpName
#write-host "2" + $hostGroup
#write-host "3" + $hostProfile
#write-host "4" + $iDracIPAddress
#write-host "5" + $isDHCP
#write-host "6" + $nicValue
#write-host "7" + $serverSvcTag
#write-host "8" + $smBiosId

$returnval = $returnval + "0"
$returnval = $returnval + "SCVMM Operation Completed Successfully"
$returnval = $returnval + "SUCCESS"
$returnval = $returnval + "Description4"
write-host "SCVMM Operation for OS Deployment Completed Successfully"
write-host "Returning from OSDeployment : " +$returnval

return $returnval