param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$smBIOSGUID)
## This script removes the SCVMM Host object by using the SMBios GUID
$debug1 = 1

# Return Value
$returnval = @()
$temp = @("null") 
  


# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}
#import SCVMM related cmdlets
import-module virtualmachinemanager

# Create SCVMM Cred obj    
    $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Could not create credentail object for the given SCVMM user"
        return $returnval
    }

# A user can have mutiple role, in Tejasconext we are connecting always as DelegatedAdmin Role.

    try 
    {
        $VMMobj = Get-SCVMMServer -ComputerName $ComputerName -Credential $scvmmcreds 
    }
    catch [exception]
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + $Error[0].Exception
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
    }

    if ( $VMMobj -eq $null)
    {
        $returnval = $returnval + "FAIL"
        $returnval = $returnval + "SCVMM host not reachable"
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
       
    }
	else
    {

		try
		{
			# Search for the Host object
			$myhost = (Get-scvmhost -VMMServer $VMMobj | where {$_.PhysicalMachine.SMBiosGUID -eq $smBIOSGUID})

			# No host found for the SMBIOS guid
			if ($myhost -eq $null)
			{
				$returnval = $returnval + "FAIL"
				$returnval = $returnval + "No matching host found in SCVMM"
				

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval

			}
			else # Host found for the SMBIOS guid return some 
			{
				try{
					Remove-SCVMHost -VMHost $myhost -Force -VMMServer $VMMobj
				}
				catch [exception]
				{
					$returnval = $returnval + "FAIL"
					$returnval = $returnval + "Failed to delete host from SCVMM"
					return $returnval
				}
				#return $myhost.PhysicalMachine
				$returnval = $returnval + "SUCCESS"
				$returnval = $returnval + "SUCCESS"
								
				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
			}
		}
		catch [exception]
		{
				$returnval = $returnval + "-2"
				$returnval = $returnval + $Error[0].Exception
				

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
		}

}