﻿$OMPSInstallKey = "HKLM:\Software\Microsoft\System Center Operations Manager\12\Setup\Powershell\V2"
$regKey = get-item $OMPSInstallKey
$OMPSInstallPath = $regKey.GetValue("InstallDirectory")
$omModule = $OMPSInstallPath + "OperationsManager"
Import-Module -Name $omModule
$fqdn = [System.Net.Dns]::GetHostByName(($env:computerName))
$computerName = $fqdn.HostName
#$mg = New-Object -TypeName "Microsoft.EnterpriseManagement.ManagementGroup" -ArgumentList @($computerName)
$mg = Get-SCOMManagementGroup

$WindowsComputer = Get-SCOMClass -Name "Microsoft.Windows.Computer"
$group = Get-SCOMMonitoringObject | Where { $_.DisplayName -eq "DellProxyMSGroup"}
$groupAgents = $group.GetRelatedMonitoringObjects($WindowsComputer,"Recursive")

$ovrdMP = Get-SCOMManagementPack | where-object {$_.Name -eq "Dell.SDK.ApplianceIP.Override"}
$applianceIPOverride = $ovrdMP.GetOverrides() | where {$_.Name -eq "Dell.SDK.OverrideApplianceIP.UMT" }
$applianceIP = $applianceIPOverride.Value


#get all MS's in MG.

$MSs = Get-SCOMManagementServer
$strPathToJSON= "\\" + $applianceIP + "\usr\share\tomcatTejas\lclogs\scom\mg\" + $mg.Name + "\toapp\json"
$strPathToAppliance = $strPathToJSON + "\managementconsoles.json"

if (-not ([string]::IsNullOrEmpty($applianceIP)))
{
    $managmentconsolesmap = @{};	
    For($i =0; $i -lt $MSs.length; $i++)
    {
        $ms = $MSs[$i]
        $Agents = @();
	    $AgentsInfo = Get-SCOMAgent -ManagementServer $ms
        for($j = 0; $j -lt $AgentsInfo.Count; $j++)
        {
	        for($k =0; $k -lt $groupAgents.Count; $k++){ 

                $AgentDiaplayName = $AgentsInfo[$j].DisplayName;
                $groupAgentDisplayName = $groupAgents[$k].DisplayName;
		        if($groupAgentDisplayName -contains $AgentDiaplayName){
		            $Agents += $AgentsInfo[$j].DisplayName;
                }
		    }
        }
        $managmentconsolesmap.add($ms.Name, $Agents);     
	}
    $managmentconsolesjson = $managmentconsolesmap |ConvertTo-Json
    $managmentconsolesjson | Out-File -FilePath $strPathToAppliance -Force -Encoding ascii
}